EditorBar should be always refresh when font size is changed
Description

I think we still have problems with appropriately EditorBar scaling when font change.

It should even be called when line_numbers is disable (for example annotation position should be update).

History

#1 - 02/03/2015 06:05 PM - Zbigniew Rebacz

- Status changed from New to Patch ready

- Assignee set to Miroslav Fidler

- % Done changed from 0 to 80

This should solve the problem (Refresh should be always called after refresh):

void EditorBar::SyncWidth()

{

    int n = editor ? editor->GetLineCount() : 0;

    int i = 0;

    while(n) {

        i++;

        n /= 10;

    }

    int w = (line_numbers && editor ? editor->GetFont()['0'] * i : 0) + 12 + 4 + annotations;

    if(w != GetWidth())

        Width(w);

    Refresh();

}

First reason is that font height can be different, but width stay the same (This issue can be spotted when scaling line numbers). Maybe we should

implement "SyncHeight" method to make code more understandable. The second reason is scaling annotation position and breakpoint position.

#2 - 02/03/2015 06:40 PM - Zbigniew Rebacz

To make it totally clear we need to calculate overall scrollbar height and if it is different than previous - refresh.

#3 - 02/03/2015 10:53 PM - Zbigniew Rebacz

scrollbar = editorbar;
#4 - 02/04/2015 04:24 PM - Zbigniew Rebacz

- File EditorBarFix.diff added

- % Done changed from 80 to 100

I think this is the best solution. More information in diff.

#5 - 02/08/2015 12:52 PM - Miroslav Fidler

- Status changed from Patch ready to Approved

thanks

Files

EditorBarFix.diff 1.7 KB 02/04/2015 Zbigniew Rebacz
